using UnityEngine;

public class BloodWireToolNP : DistanceWireTool
{
    private void Awake()
    {
        this.WireMaterial = Resources.Load<Material>("Materials/BloodWire");
        this.WireMaterial.mainTexture = NP.NP.NP_bloodpipe;
        NP.NP.NP_bloodpipe.wrapMode = TextureWrapMode.Repeat;
        this.WireColor = Color.white;
        this.AllowNothingConnection = false;
        this.WireWidth = 0.1f;
    }

    public override void OnToolChosen()
    {
        base.OnToolChosen();
        MaterialPropertyBlock properties = new MaterialPropertyBlock();
        this.lineRenderer.GetPropertyBlock(properties);
        properties.SetFloat(ShaderProperties.Get("_Flow"), 0.0f);
        this.lineRenderer.SetPropertyBlock(properties);
    }

    protected override void OnJointCreate(DistanceJoint2D joint)
    {
        BloodWireBehaviourNP bloodWireBehaviour = joint.gameObject.AddComponent<BloodWireBehaviourNP>();
        UndoControllerBehaviour.RegisterAction((IUndoableAction)new ObjectCreationAction((Object)bloodWireBehaviour, "blood wire"));
        bloodWireBehaviour.typedJoint = joint;
        bloodWireBehaviour.Joint_Anchor = joint.anchor;
        bloodWireBehaviour.Joint_ConnectedAnchor = joint.connectedAnchor;
        bloodWireBehaviour.WireColor = this.WireColor;
        bloodWireBehaviour.WireMaterial = this.WireMaterial;
        bloodWireBehaviour.WireWidth = this.WireWidth;
    }
}
