using UnityEngine;
using System;

namespace NP
{
    public class NP_Water : Liquid
    {
        public const string ID = "NP_WATER";

        public override string GetDisplayName() => "Water";

        public NP_Water() => this.Color = new Color(0.5f, 0.65f, 0.9f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
            if (!(container is CirculationBehaviour circulationBehaviour) || !(circulationBehaviour.Limb.SpeciesIdentity == "Android"))
                return;
            circulationBehaviour.Limb.PhysicalBehaviour.Charge += 5f;
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_HPS : Liquid
    {
        public const string ID = "NP_HPS";

        public override string GetDisplayName() => "High Pressure Steam";

        public NP_HPS() => this.Color = new Color(0.8f, 0.8f, 0.8f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
            if (!(container is CirculationBehaviour circulationBehaviour))
                return;
            container.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 0.1f;
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_ExhaustSteam : Liquid
    {
        public const string ID = "NP_EXHAUSTSTEAM";

        public override string GetDisplayName() => "Exhaust Steam";

        public NP_ExhaustSteam() => this.Color = new Color(0.5f, 0.5f, 0.5f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
            if (!(container is CirculationBehaviour circulationBehaviour))
                return;
            container.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 0.05f;
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }


    //Fusion fuels and byproducts


    public class NP_Hydrogen : Liquid
    {
        public const string ID = "NP_HYDROGEN";

        public override string GetDisplayName() => "Hydrogen-1 (protium)";

        public NP_Hydrogen() => this.Color = new Color(0.6f, 0.9f, 1f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_Deuterium : Liquid
    {
        public const string ID = "NP_DEUTERIUM";

        public override string GetDisplayName() => "Hydrogen-2 (deuterium)";

        public NP_Deuterium() => this.Color = new Color(0.7f, 0.8f, 0.9f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_Tritium : Liquid
    {
        public const string ID = "NP_TRITIUM";

        public override string GetDisplayName() => "Hydrogen-3 (tritium)";

        public NP_Tritium() => this.Color = new Color(0.7f, 0.7f, 0.8f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_Helium3 : Liquid
    {
        public const string ID = "HELIUM3";

        public override string GetDisplayName() => "Helium-3";

        public NP_Helium3() => this.Color = new Color(0.9f, 0.8f, 0.8f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
    public class NP_Helium4 : Liquid
    {
        public const string ID = "HELIUM4";

        public override string GetDisplayName() => "Helium-4";

        public NP_Helium4() => this.Color = new Color(1f, 0.8f, 0.9f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
}
