using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class Fusion : MonoBehaviour
    {
        public LightSprite glow;
        bool FLight = false;
        public bool Ignite;
        public string FuelType = "null";
        public float FuelTime;
        public float MultiplierFusion = 1f;

        public Liquid hydrogen = Liquid.GetLiquid("NP_HYDROGEN");
        public Liquid deuterium = Liquid.GetLiquid("NP_DEUTERIUM");
        public Liquid tritium = Liquid.GetLiquid("NP_TRITIUM");
        public Liquid helium3 = Liquid.GetLiquid("NP_HELIUM3");
        public Liquid helium4 = Liquid.GetLiquid("NP_HELIUM4");
        private bool FusionHeating;
        private int done = 5;
        WaterTank child1;
        WaterTank child2;
        WaterTank child3;



        private void FixedUpdate()
        {
            if (done < 1 && done > -1)
            {
                done = -100;
                child1 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[0].ToString()).GetComponent<WaterTank>();
                child2 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[1].ToString()).GetComponent<WaterTank>();
                child3 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[2].ToString()).GetComponent<WaterTank>();
                //ModAPI.Notify("Test: " + child1.UpperLimit);
            }
            else if (done > 0)
            {
                done--;
            }

            if (FLight == false)
            {
                glow = ModAPI.CreateLight(transform, new Color(0.7f, 0.3f, 1f, 1f), 1, 1);
                FLight = true;
            }
            if (GetComponent<PhysicalBehaviour>().Charge > 250000f && FusionHeating == true && child1.ScaledLiquidAmount > 0.01f && child1.ScaledLiquidAmount > 0.01f)
            {
                GetComponent<PhysicalBehaviour>().Temperature += 10000f;
                GetComponent<PhysicalBehaviour>().Temperature *= 1.01f;
            }
            if (GetComponent<PhysicalBehaviour>().Temperature > 10000000f && GetComponent<PhysicalBehaviour>().Charge > 250000f && Ignite == false && child1.ScaledLiquidAmount > 0.01f && child1.ScaledLiquidAmount > 0.01f)
            {
                Ignite = true;
            }
            else if(Ignite == true && GetComponent<PhysicalBehaviour>().Charge > 50f && GetComponent<PhysicalBehaviour>().Temperature > 5000000f)
            {
                FusionHeating = false;
                if (child1.GetPercentageOf(deuterium) * child1.UpperLimit > 2.8f * 1f && child2.GetPercentageOf(deuterium) * child2.UpperLimit > 2.8f * 1f && !(child3.IsFull(0.95f)) && GetComponent<PhysicalBehaviour>().Temperature < 1200000000f)
                {
                    FusionHeating = true;
                    if (GetComponent<PhysicalBehaviour>().Temperature > 400000000f)
                    {
                        GetComponent<PhysicalBehaviour>().Temperature *= 1.00525f;
                        glow.Radius = 0.1f;
                        glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.0001f;
                        glow.Color = new Color(0.9f, 0.3f, 0.5f, 1f);
                        child3.AddLiquid(helium3, 2.8f * 0.005f * MultiplierFusion);
                        child3.AddLiquid(tritium, 2.8f * 0.0025f * MultiplierFusion);
                        child3.AddLiquid(helium4, 2.8f * 0.0025f * MultiplierFusion);
                        child1.RemoveLiquid(deuterium, 2.8f * 0.01f * MultiplierFusion);
                        child2.RemoveLiquid(deuterium, 2.8f * 0.01f * MultiplierFusion);
                        this.gameObject.GetComponent<Fuel>().NeutronRadius = 3f;
                        this.gameObject.GetOrAddComponent<Radiation>().RadiationN = 0.5f * 100f;
                        this.gameObject.GetOrAddComponent<Fuel>().VariableNeutronFlux = 0.5f * 100f;
                        FusionHeating = false;
                    }
                }
                else if (child1.GetPercentageOf(deuterium) * child1.UpperLimit > 2.8f * 1f && child2.GetPercentageOf(tritium) * child2.UpperLimit > 2.8f * 1f && !(child3.IsFull(0.95f)) && GetComponent<PhysicalBehaviour>().Temperature < 300000000f)
                {
                    FusionHeating = true;
                    if (GetComponent<PhysicalBehaviour>().Temperature > 100000000f)
                    {
                        GetComponent<PhysicalBehaviour>().Temperature *= 1.0176f;
                        glow.Radius = 0.1f;
                        glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.0001f;
                        glow.Color = new Color(0.9f, 0.4f, 0.9f, 1f);
                        child3.AddLiquid(helium4, 2.8f * 0.01f * MultiplierFusion);
                        child1.RemoveLiquid(deuterium, 2.8f * 0.01f * MultiplierFusion);
                        child2.RemoveLiquid(tritium, 2.8f * 0.01f * MultiplierFusion);
                        this.gameObject.GetComponent<Fuel>().NeutronRadius = 5f;
                        this.gameObject.GetOrAddComponent<Radiation>().RadiationN = 1f * 100f;
                        this.gameObject.GetOrAddComponent<Fuel>().VariableNeutronFlux = 1f * 100f;
                        FusionHeating = false;
                    }
                }
                else if (child1.GetPercentageOf(deuterium) * child1.UpperLimit > 2.8f * 1f && child2.GetPercentageOf(helium3) * child2.UpperLimit > 2.8f * 1f && !(child3.IsFull(0.95f)) && GetComponent<PhysicalBehaviour>().Temperature < 1800000000f)
                {
                    if (GetComponent<PhysicalBehaviour>().Temperature > 600000000f)
                    {
                        GetComponent<PhysicalBehaviour>().Temperature *= 1.0183f;
                        glow.Radius = 0.1f;
                        glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.0001f;
                        glow.Color = new Color(0.5f, 0.2f, 1f, 1f);
                        child3.AddLiquid(helium4, 2.8f * 0.01f * MultiplierFusion);
                        child3.AddLiquid(hydrogen, 2.8f * 0.01f * MultiplierFusion);
                        child1.RemoveLiquid(deuterium, 2.8f * 0.01f * MultiplierFusion);
                        child2.RemoveLiquid(helium3, 2.8f * 0.01f * MultiplierFusion);
                        this.gameObject.gameObject.GetComponent<Fuel>().NeutronRadius = 5f;
                        this.gameObject.GetOrAddComponent<Radiation>().RadiationN = 0.1f * 100f;
                        FusionHeating = false;
                    }
                    FusionHeating = true;
                }
                if (GetComponent<PhysicalBehaviour>().Temperature < 50000000f)
                {
                    glow.Radius = 0.1f;
                    glow.Brightness = GetComponent<PhysicalBehaviour>().Temperature * 0.00005f;
                    glow.Color = new Color(0.5f, 0.15f, 0.15f, 1f);
                    if(GetComponent<PhysicalBehaviour>().Temperature > 100000f)
                        GetComponent<PhysicalBehaviour>().Temperature -= 10000f;
                    this.gameObject.GetComponent<Fuel>().NeutronRadius = 0f;
                    this.gameObject.GetOrAddComponent<Radiation>().RadiationN = 0f;
                    FusionHeating = true;
                }
            }
            else
            {
                if (GetComponent<PhysicalBehaviour>().Temperature > 100000f && GetComponent<PhysicalBehaviour>().Charge < 250000f)
                    GetComponent<PhysicalBehaviour>().Temperature *= 0.95f;
                Ignite = false;
                glow.Radius = 0f;
                glow.Brightness = 0;
                FusionHeating = true;
            }
        }
    }
}
