using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class HeatSensor : MonoBehaviour
    {
        
        public float currentheat = 100f;
        public bool reverse = false;

        private void Awake()
        {
                this.gameObject.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("heatset", "Set Heat", "Set Heat.", new UnityAction[1]
                {
            (UnityAction) (() =>
            {
              DialogBox dialog = (DialogBox) null;
              dialog = DialogBoxManager.TextEntry("Enter heat\n<color=blue><size=26>Default: 100,Currently:" + this.currentheat.ToString() + "</size></color>", "Number", new DialogButton("Apply", true, new UnityAction[1]
              {
                (UnityAction) (() =>
                {
                  float result;
                  if (!float.TryParse(dialog.EnteredText, out result))
                    return;
                  this.currentheat = result;
                })
              }), new DialogButton("Cancel", true, new UnityAction[1]
              {
                (UnityAction) (() => dialog.Close())
              }));
            })
                }));
        }

        private void Use(ActivationPropagation activation)
        {
            if (activation.Channel == (ushort)2)
            {
                if(reverse)
                    reverse = false;
                else
                    reverse = true;
            }
        }

        private void FixedUpdate()
        {
            if(reverse)
            {
                if (currentheat > GetComponent<PhysicalBehaviour>().Temperature)
                {
                    foreach (ushort allChannel in ActivationPropagation.AllChannels)
                        this.SendMessage("UseContinuous", (object)new ActivationPropagation((UnityEngine.Object)this.transform.root, allChannel), SendMessageOptions.DontRequireReceiver);
                }
            }
            else
            {
                if (currentheat < GetComponent<PhysicalBehaviour>().Temperature)
                {
                    foreach (ushort allChannel in ActivationPropagation.AllChannels)
                        this.SendMessage("UseContinuous", (object)new ActivationPropagation((UnityEngine.Object)this.transform.root, allChannel), SendMessageOptions.DontRequireReceiver);
                }
            }

        }

    }
}
