using UnityEngine;

namespace NP
{
    public class NP
    {
        //public static AudioClip geigerclick = ModAPI.LoadSound("Sounds/geiger.wav");
        public static Texture NP_bloodpipe = ModAPI.LoadTexture("Textures/FluidPipe1.png");


        public static void CreateFlask(
          string liquidID,
          string name,
          string nameOverride,
          string description,
          Category category,
          float amount = 2f,
          string spritename = "waterflask.png")
        {
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Flask"),
                NameOverride = name,
                NameToOrderByOverride = nameOverride,
                DescriptionOverride = description,
                CategoryOverride = category,
                ThumbnailOverride = ModAPI.LoadSprite(spritename),
                AfterSpawn = (System.Action<GameObject>)(Instance => Instance.GetComponent<FlaskBehaviour>().StartLiquid = new BloodContainer.SerialisableDistribution()
                {
                    LiquidID = liquidID,
                    Amount = amount
                })
            });
        }

        public static void Main()
        {

            ModAPI.RegisterLiquid("NP_WATER", new NP_Water());
            ModAPI.RegisterLiquid("NP_HPS", new NP_HPS());
            ModAPI.RegisterLiquid("NP_EXHAUSTSTEAM", new NP_ExhaustSteam());

            ModAPI.RegisterLiquid("NP_HYDROGEN", new NP_Hydrogen());
            ModAPI.RegisterLiquid("NP_DEUTERIUM", new NP_Deuterium());
            ModAPI.RegisterLiquid("NP_TRITIUM", new NP_Tritium());
            ModAPI.RegisterLiquid("NP_HELIUM3", new NP_Helium3());
            ModAPI.RegisterLiquid("NP_HELIUM4", new NP_Helium4());

            CategoryBuilder.Create("NuclearPlayground", "A category full of your nuclear needs. (I know many people hate mods adding their own categories but it was just getting too ridiculous in the machinery tab) Thanks to RustyPupper for the code and basically all the work on this", ModAPI.LoadSprite("thumbnailcategory.png"));

            NP.CreateFlask("NP_HYDROGEN", "Flask Of Hydrogen", "NPZZFusion02", "Temporary way to get fluids. No fusion reactions yet.", ModAPI.FindCategory("NuclearPlayground"));
            NP.CreateFlask("NP_DEUTERIUM", "Flask Of Deuterium", "NPZZFusion03", "Temporary way to get fluids. D-D and D-T fusion reactions.", ModAPI.FindCategory("NuclearPlayground"));
            NP.CreateFlask("NP_TRITIUM", "Flask Of Tritium", "NPZZFusion04", "Temporary way to get fluids. D-T fusion reaction.", ModAPI.FindCategory("NuclearPlayground"));
            NP.CreateFlask("NP_HELIUM3", "Flask Of Helium-3", "NPZZFusion05", "Temporary way to get fluids. D-He3 fusion reaction.", ModAPI.FindCategory("NuclearPlayground"));
            NP.CreateFlask("NP_HELIUM4", "Flask Of Helium-4", "NPZZFusion06", "Temporary way to get fluids. No fusion reactions yet.", ModAPI.FindCategory("NuclearPlayground"));

            ModAPI.RegisterTool<BloodWireToolNP>(
                "One way fluid pipe",
                "Ultra fast one way pipe for use in nuclear reactors.",
                ModAPI.LoadSprite("Thumbnails/PipeTool1View.png"),
                "Wire"
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Super Capacitor -NP",
                    NameToOrderByOverride = "NPZZFusion01",
                    DescriptionOverride = "High power capacitor used to start fusion reactor. Should be connected directly to reduce power loss. They will send out propagatrion signal after turning off to make chaning them possible.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SuperCapacitorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SuperCapacitor.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        Instance.GetOrAddComponent<SuperCapacitor>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Small Turbine -NP (Cooling loop)",
                    NameToOrderByOverride = "NPTurbine01",
                    DescriptionOverride = "Connect to high pressure steam (Red port) from boilers to generate electricity and exhaust steam (Blue port). Small variant",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/TurbineSmallView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineSmall.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<TurbineNew>().MultiplierTurbine = 0.2f;
                        Instance.GetOrAddComponent<TurbineNew>().MaxThroughput = 1f;
                        Instance.GetOrAddComponent<CreateChild>().size = 2;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-0.855f, 0.3143f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Turbine Input S -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(-0.855f, -0.3145f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Turbine Output S -NP");
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Medium Turbine -NP (Cooling loop)",
                    NameToOrderByOverride = "NPTurbine02",
                    DescriptionOverride = "Connect to high pressure steam (Red port) from boilers to generate electricity and exhaust steam (Blue port). Medium variant",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/TurbineMediumView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineMedium.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<TurbineNew>().MultiplierTurbine = 0.5f;
                        Instance.GetOrAddComponent<TurbineNew>().MaxThroughput = 5f;
                        Instance.GetOrAddComponent<CreateChild>().size = 2;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-0.855f * 2f, 0.3143f * 2f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Turbine Input M -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(-0.855f * 2f, -0.3145f * 2f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Turbine Output M -NP");
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Large Turbine -NP (Cooling loop)",
                    NameToOrderByOverride = "NPTurbine03",
                    DescriptionOverride = "Connect to high pressure steam (Red port) from boilers to generate electricity and exhaust steam (Blue port). Big variant",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/TurbineLargeView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineLarge.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 100f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 100f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<TurbineNew>().MultiplierTurbine = 1f;
                        Instance.GetOrAddComponent<TurbineNew>().MaxThroughput = 25f;
                        Instance.GetOrAddComponent<CreateChild>().size = 2;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-0.855f * 3f, 0.3143f * 3f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Turbine Input L -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(-0.855f * 3f, -0.3145f * 3f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Turbine Output L -NP");
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Cooling Tower -NP (Cooling loop)",
                    NameToOrderByOverride = "NPTurbine04",
                    DescriptionOverride = "Used to turn exhaust steam (Red port) from turbines back into water (Blue port) (Needs additional water input in dark blue port)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/CoolingTowerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CoolingTower.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 500f;
                        Instance.GetOrAddComponent<CoolingTowerNew>().MultiplierCoolingTower = 1f;
                        Instance.GetOrAddComponent<CoolingTowerNew>().MaxThroughput = 250f;
                        Instance.GetOrAddComponent<CreateChild>().size = 3;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-396f * ModAPI.PixelSize, -412.5f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Turbine Input L -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(-396f * ModAPI.PixelSize, -465.5f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Turbine Output L -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[2] = new Vector3(-396f * ModAPI.PixelSize, -492.5f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[2] = ModAPI.FindSpawnable("Cooling Tower Coolant L -NP");
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Water Boiler -NP (Cooling loop)",
                    NameToOrderByOverride = "NPTurbineB01",
                    DescriptionOverride = "Used to turn water (Blue port )into HPS (Red port) using heat.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/BoilerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Boiler.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 30f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 30f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<Boiler>().MultiplierBoiler = 0.2f;
                        Instance.GetOrAddComponent<CreateChild>().size = 2;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-37f * ModAPI.PixelSize, -8f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Boiler Input S -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(-37f * ModAPI.PixelSize, 12f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Boiler Output S -NP");
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Water Block -NP",
                    NameToOrderByOverride = "NPTurbineZ",
                    DescriptionOverride = "Doesn't have actual water physics, used for decoration though it does cool down its collision box (Grab from the bottom because that is where collision box is)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/WaterBlockView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WaterBlock.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 50f;
                        foreach (UnityEngine.Object component in Instance.GetComponents<Collider2D>())
                            UnityEngine.Object.Destroy(component);
                        BoxCollider2D boxCollider2D = Instance.AddComponent<BoxCollider2D>();
                        boxCollider2D.size = new Vector2(5.5f, 0.1f);
                        boxCollider2D.offset = new Vector2(0f, -2.75f);
                        BoxCollider2D boxCollider2D1 = Instance.AddComponent<BoxCollider2D>();
                        boxCollider2D1.size = new Vector2(5.5f, 5.5f);
                        boxCollider2D1.offset = new Vector2(0f, 0f);
                        boxCollider2D1.isTrigger = true;
                        //Instance.GetOrAddComponent<WaterBlock>();
                        //Instance.GetOrAddComponent<WaterPump>().LiquidID = "NP_WATER";
                        //Instance.GetComponent<WaterPump>().Amount = 1f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Water Pump -NP",
                    NameToOrderByOverride = "NPTurbineB02",
                    DescriptionOverride = "Put underwater to pump clean water.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/WaterPumpView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WaterPump.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 3f;
                        Instance.GetOrAddComponent<WaterPump>().LiquidID = "NP_WATER";
                        Instance.GetComponent<WaterPump>().Amount = 1f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LEU-235 -NP",
                    NameToOrderByOverride = "NPFuelNuclear01",
                    DescriptionOverride = "Most basic fuel for Nuclear reactors (Meltdown > 5000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LEU-235 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LEU-235 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 2f;
                        Instance.GetComponent<Fuel>().Criticality = 35f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3f;
                        Instance.GetComponent<Fuel>().FuelTime = 3000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 2f;
                        Instance.GetComponent<Radiation>().RadiationA = 20f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HEU-235 -NP",
                    NameToOrderByOverride = "NPFuelNuclear02",
                    DescriptionOverride = "Contains much more fissile isotope (U-235) than LEU (Meltdown > 8000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HEU-235 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HEU-235 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 4f;
                        Instance.GetComponent<Fuel>().Criticality = 20f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 1500f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3f;
                        Instance.GetComponent<Radiation>().RadiationA = 30f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LEU-233 -NP",
                    NameToOrderByOverride = "NPFuelNuclear03",
                    DescriptionOverride = "Uranium fuel with isotpe U-233 instead of U-235 making it much hotter (Meltdown > 7250C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LEU-233 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LEU-233 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3.5f;
                        Instance.GetComponent<Fuel>().Criticality = 30f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 2500f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3f;
                        Instance.GetComponent<Radiation>().RadiationA = 35f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HEU-233 -NP",
                    NameToOrderByOverride = "NPFuelNuclear04",
                    DescriptionOverride = "Contains much more fissile isotope (U-233) than LEU-233 making it even hotter (Meltdown > 16000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HEU-233 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HEU-233 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.7f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.7f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 7f;
                        Instance.GetComponent<Fuel>().Criticality = 17f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1250f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 4f;
                        Instance.GetComponent<Radiation>().RadiationA = 40f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "MOX-239 -NP",
                    NameToOrderByOverride = "NPFuelNuclear05",
                    DescriptionOverride = "Uses Pu-239 instead of U-235 as fissile isotope (Meltdown > 5450C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/MOX-239 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/MOX-239 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 2.3f;
                        Instance.GetComponent<Fuel>().Criticality = 30f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 4000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 2.5f;
                        Instance.GetComponent<Radiation>().RadiationA = 50f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LEP-239 -NP",
                    NameToOrderByOverride = "NPFuelNuclear06",
                    DescriptionOverride = "Nuclear fuel made completely out of plutonium isotopes (Meltdown > 6500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LEP-239 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LEP-239 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 15f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3f;
                        Instance.GetComponent<Fuel>().Criticality = 25f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3f;
                        Instance.GetComponent<Fuel>().FuelTime = 2000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3f;
                        Instance.GetComponent<Radiation>().RadiationA = 60f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HEP-239 -NP",
                    NameToOrderByOverride = "NPFuelNuclear07",
                    DescriptionOverride = "Highly enriched nuclear fuel made completely out of plutonium isotopes (Meltdown > 11000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HEP-239 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HEP-239 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 16f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 16f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 6f;
                        Instance.GetComponent<Fuel>().Criticality = 16f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 4f;
                        Instance.GetComponent<Radiation>().RadiationA = 70f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LEA-242 -NP",
                    NameToOrderByOverride = "NPFuelNuclear08",
                    DescriptionOverride = "Highly reactive and short lived fuel made from americium (Meltdown > 6500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LEA-242 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LEA-242 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3f;
                        Instance.GetComponent<Fuel>().Criticality = 20f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3f;
                        Instance.GetComponent<Fuel>().FuelTime = 1500f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 6f;
                        Instance.GetComponent<Radiation>().RadiationA = 50f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HEA-242 -NP",
                    NameToOrderByOverride = "NPFuelNuclear09",
                    DescriptionOverride = "Even more reactive version of LEA-242 fuel (Meltdown > 8000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HEA-242 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HEA-242 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 16f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 16f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 4f;
                        Instance.GetComponent<Fuel>().Criticality = 13f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 750f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 9f;
                        Instance.GetComponent<Radiation>().RadiationA = 60f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LECm-243 -NP",
                    NameToOrderByOverride = "NPFuelNuclear10",
                    DescriptionOverride = "Very hot and short lived fuel  (Meltdown > 10500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LECm-243 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LECm-243 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 16f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 16f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 7f;
                        Instance.GetComponent<Fuel>().Criticality = 20f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1500f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 10f;
                        Instance.GetComponent<Radiation>().RadiationA = 70f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HECm-243 -NP",
                    NameToOrderByOverride = "NPFuelNuclear11",
                    DescriptionOverride = "even hotter short lived fuel  (Meltdown > 21500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HECm-243 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HECm-243 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 16f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 16f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 13f;
                        Instance.GetComponent<Fuel>().Criticality = 13f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 900f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 12f;
                        Instance.GetComponent<Radiation>().RadiationA = 100f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LEB-248 -NP",
                    NameToOrderByOverride = "NPFuelNuclear12",
                    DescriptionOverride = "Slightly stronger fuel than LECm-243 (Meltdown > 15500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LEB-248 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LEB-248 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 17f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 17f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 9f;
                        Instance.GetComponent<Fuel>().Criticality = 17f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1300f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 11f;
                        Instance.GetComponent<Radiation>().RadiationA = 80f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HEB-248 -NP",
                    NameToOrderByOverride = "NPFuelNuclear13",
                    DescriptionOverride = "Slightly stronger fuel than HECm-243  (Meltdown > 26000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HEB-248 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HEB-248 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 17f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 17f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 16f;
                        Instance.GetComponent<Fuel>().Criticality = 11f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 800f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 14f;
                        Instance.GetComponent<Radiation>().RadiationA = 120f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "LECf-249 -NP",
                    NameToOrderByOverride = "NPFuelNuclear14",
                    DescriptionOverride = "Very dangerous and radioactive fuel (Meltdown > 24500C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LECf-249 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LECf-249 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 19f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 19f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 15f;
                        Instance.GetComponent<Fuel>().Criticality = 8f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 8f;
                        Instance.GetComponent<Fuel>().FuelTime = 1300f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 20f;
                        Instance.GetComponent<Radiation>().RadiationA = 80f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "HECf-249 -NP",
                    NameToOrderByOverride = "NPFuelNuclear15",
                    DescriptionOverride = "Even more dangerous fuel that will activate from almost any neutron flux (Meltdown > 29000C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HECf-249 FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HECf-249 Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 18.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 18.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 18f;
                        Instance.GetComponent<Fuel>().Criticality = 4f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 10f;
                        Instance.GetComponent<Fuel>().FuelTime = 800f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 30f;
                        Instance.GetComponent<Radiation>().RadiationA = 150f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "TBU -NP",
                    NameToOrderByOverride = "NPFuelNuclear00",
                    DescriptionOverride = "Very efficent but hard to use fuel, doesn't achieve as high temperature as others and is hard to get criticality (also doesn't produce any neutron flux) (Meltdown > 2750C)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/TBU FuelView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TBU Fuel.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.5f;
                        Instance.GetComponent<Fuel>().Criticality = 100f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 10000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1f;
                        Instance.GetComponent<Radiation>().RadiationA = 15f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Uranium ore -NP",
                    NameToOrderByOverride = "NPOres01",
                    DescriptionOverride = "Uranium can be extracted using fuel reprocessor",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/UraniumOreView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/UraniumOre.png" , 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 1f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.3f;
                        Instance.GetComponent<Radiation>().RadiationA = 5f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Thorium ore -NP",
                    NameToOrderByOverride = "NPOres02",
                    DescriptionOverride = "Thorium-232 and small amounts of uranium-233 can be extracted using fuel reprocessor",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/ThoriumOreView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ThoriumOre.png" , 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.5f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.5f;
                        Instance.GetComponent<Radiation>().RadiationA = 10f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pu-238 -NP",
                    NameToOrderByOverride = "NPIsotopes01",
                    DescriptionOverride = "Plutonium isotope that has a lot of decay heat but can't be used in reactors by itself (trust me don't use it in reactors it won't work)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pu-238View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pu-238.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9.8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9.8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 300f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.1f;
                        Instance.GetComponent<Radiation>().RadiationA = 100f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Sr-90 -NP",
                    NameToOrderByOverride = "NPIsotopes02",
                    DescriptionOverride = "Isotope of strontium, Waste from thorium reprocessing.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Sr-90View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Sr-90.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 53f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 11f;
                        Instance.GetComponent<Radiation>().RadiationA = 320f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cs-137 -NP",
                    NameToOrderByOverride = "NPIsotopes03",
                    DescriptionOverride = "Isotope of cesium, Waste from uranium reprocessing. Also explodes in water",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cs-137View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cs-137.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 50f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 10f;
                        Instance.GetComponent<Radiation>().RadiationA = 300f;
                        Instance.GetOrAddComponent<Cesium>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pm-147 -NP",
                    NameToOrderByOverride = "NPIsotopes040",
                    DescriptionOverride = "Isotope of promethium, Waste from plutonium and americium reprocessing.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pm-147View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pm-147.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 8.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 8.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 80f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 100f;
                        Instance.GetComponent<Radiation>().RadiationA = 3000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Eu-155 -NP",
                    NameToOrderByOverride = "NPIsotopes041",
                    DescriptionOverride = "Isotope of europium, Waste from HECf fuel reprocessing.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Eu-155View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Eu-155.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 7f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 7f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 60f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 70f;
                        Instance.GetComponent<Radiation>().RadiationA = 2000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Ru-106 -NP",
                    NameToOrderByOverride = "NPIsotopes042",
                    DescriptionOverride = "Isotope of ruthenium, Waste from LECf fuel reprocessing.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Ru-106View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Ru-106.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 100f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 150f;
                        Instance.GetComponent<Radiation>().RadiationA = 6000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Co-60 -NP",
                    NameToOrderByOverride = "NPIsotopes043",
                    DescriptionOverride = "Isotope of cobalt, made from irradiating natural cobalt.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Co-60View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Co-60.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 10f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 600f;
                        Instance.GetComponent<Radiation>().RadiationA = 1000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Au-198 -NP",
                    NameToOrderByOverride = "NPIsotopes044",
                    DescriptionOverride = "Isotope of gold, made from irradiating natural gold. Extremely radioactive killing anyone nearby",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Au-198View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Au-198.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 11f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 11f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 500f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 10f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1000000f;
                        Instance.GetComponent<Radiation>().RadiationA = 10000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Po-210 -NP",
                    NameToOrderByOverride = "NPIsotopes045",
                    DescriptionOverride = "Isotope of polonium, made from irradiating bismuth.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Po-210View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Po-210.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 10f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 10f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 100f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 0.7f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 2000f;
                        Instance.GetComponent<Radiation>().RadiationA = 3000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Th-232 -NP",
                    NameToOrderByOverride = "NPIsotopes05",
                    DescriptionOverride = "Fertile isotope of thorium. Can be irradiated into Uranium-233",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Th-232View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Th-232.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.1f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 2f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.25f;
                        Instance.GetComponent<Radiation>().RadiationA = 13f;
                        Instance.GetOrAddComponent<Irradiator>().Isotope = "U-233 -NP";
                        Instance.GetComponent<Irradiator>().NeededFlux = 2500f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "U-238 -NP",
                    NameToOrderByOverride = "NPIsotopes06",
                    DescriptionOverride = "Fertile isotope of uranium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/U-238View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/U-238.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.1f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 2f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.2f;
                        Instance.GetComponent<Radiation>().RadiationA = 10f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "U-235 -NP",
                    NameToOrderByOverride = "NPIsotopes07",
                    DescriptionOverride = "Fissile isotope of uranium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/U-235View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/U-235.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.3f;
                        Instance.GetComponent<Fuel>().Criticality = 20f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.25f;
                        Instance.GetComponent<Radiation>().RadiationA = 13f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "U-233 -NP",
                    NameToOrderByOverride = "NPIsotopes08",
                    DescriptionOverride = "Another Fissile isotope of uranium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/U-233View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/U-233.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5.4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5.4f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 1.2f;
                        Instance.GetComponent<Fuel>().Criticality = 18f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.3f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3f;
                        Instance.GetComponent<Radiation>().RadiationA = 30f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pu-242 -NP",
                    NameToOrderByOverride = "NPIsotopes09",
                    DescriptionOverride = "Fertile isotope of plutonium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pu-242View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pu-242.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 1.3f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1f;
                        Instance.GetComponent<Radiation>().RadiationA = 20f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pu-239 -NP",
                    NameToOrderByOverride = "NPIsotopes10",
                    DescriptionOverride = "Fissile isotope of plutonium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pu-239View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pu-239.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 2f;
                        Instance.GetComponent<Fuel>().Criticality = 19f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 10f;
                        Instance.GetComponent<Radiation>().RadiationA = 40f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Am-243 -NP",
                    NameToOrderByOverride = "NPIsotopes11",
                    DescriptionOverride = "Fertile isotope of americium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Am-243View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Am-243.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3.5f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 2f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 15f;
                        Instance.GetComponent<Radiation>().RadiationA = 55f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Am-242 -NP",
                    NameToOrderByOverride = "NPIsotopes12",
                    DescriptionOverride = "Fissile isotope of americium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Am-242View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Am-242.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 5f;
                        Instance.GetComponent<Fuel>().Criticality = 16f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.6f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 35f;
                        Instance.GetComponent<Radiation>().RadiationA = 100f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cm-246 -NP",
                    NameToOrderByOverride = "NPIsotopes13",
                    DescriptionOverride = "Fertile isotope of curium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cm-246View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cm-246.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 5f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 2f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 16f;
                        Instance.GetComponent<Radiation>().RadiationA = 60f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cm-243 -NP",
                    NameToOrderByOverride = "NPIsotopes14",
                    DescriptionOverride = "Fissile isotope of curium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cm-243View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cm-243.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.3f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 15f;
                        Instance.GetComponent<Fuel>().Criticality = 14f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3.7f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 100f;
                        Instance.GetComponent<Radiation>().RadiationA = 200f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bk-247 -NP",
                    NameToOrderByOverride = "NPIsotopes15",
                    DescriptionOverride = "Fertile isotope of berkelium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bk-247View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Bk-247.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.5f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 4f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 2f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 30f;
                        Instance.GetComponent<Radiation>().RadiationA = 80f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bk-248 -NP",
                    NameToOrderByOverride = "NPIsotopes16",
                    DescriptionOverride = "Fissile isotope of berkelium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bk-248View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Bk-248.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6.8f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6.8f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 5f;
                        Instance.GetComponent<Fuel>().Criticality = 10f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 40f;
                        Instance.GetComponent<Radiation>().RadiationA = 100f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cf-252 -NP",
                    NameToOrderByOverride = "NPIsotopes17",
                    DescriptionOverride = "Fertile isotope of californium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cf-252View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cf-252.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 8.4f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 8.4f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 50f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 200f;
                        Instance.GetComponent<Radiation>().RadiationA = 2000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cf-249 -NP",
                    NameToOrderByOverride = "NPIsotopes18",
                    DescriptionOverride = "Fissile isotope of californium",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cf-249View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cf-249.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 8.2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 8.2f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 25f;
                        Instance.GetComponent<Fuel>().Criticality = 7f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 1000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 30f;
                        Instance.GetComponent<Radiation>().RadiationA = 80f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cf-250 -NP",
                    NameToOrderByOverride = "NPIsotopes19",
                    DescriptionOverride = "Isotope of californium generating extremely high amount of heat.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cf-250View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cf-250.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 8.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 8.3f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 900f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1.5f;
                        Instance.GetComponent<Fuel>().FuelTime = 10f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 20f;
                        Instance.GetComponent<Radiation>().RadiationA = 3000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cf-253 -NP",
                    NameToOrderByOverride = "NPIsotopes20",
                    DescriptionOverride = "Extremely radioactive isotope of californium, do not bring close to any neutron sources. Releases so much radiation that it can activate most nuclear fuels on its own requiring special containers for save transport.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cf-253View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cf-253.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 80f;
                        Instance.GetComponent<Fuel>().Criticality = 1f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 7f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1500f;
                        Instance.GetComponent<Radiation>().RadiationA = 1000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Es-253 -NP",
                    NameToOrderByOverride = "NPIsotopes201",
                    DescriptionOverride = "Cf-253 is nothing compared to this isotope, bringing it near any source of neutrons might bring your doom or of anyone standing nearby. (can be rarely separated instead of Cf-253)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Es-253View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Es-253.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 9f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 9f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 80f;
                        Instance.GetComponent<Fuel>().Criticality = 0.3f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 7f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 5000f;
                        Instance.GetComponent<Radiation>().RadiationA = 10000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cobalt -NP",
                    NameToOrderByOverride = "NPIsotopes21",
                    DescriptionOverride = "Natural cobalt consisting of Cobalt-59 isotope",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/CoView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Co.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 11f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 11f;
                        Instance.GetOrAddComponent<Irradiator>().Isotope = "Co-60 -NP";
                        Instance.GetComponent<Irradiator>().NeededFlux = 5000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Gold -NP",
                    NameToOrderByOverride = "NPIsotopes22",
                    DescriptionOverride = "Natural Gold consisting of Gold-197 isotope, can be irradiated into EXTREMELY radioactive isotope of gold-198",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/AuView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Au.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 12f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 12f;
                        Instance.GetOrAddComponent<Irradiator>().Isotope = "Au-198 -NP";
                        Instance.GetComponent<Irradiator>().NeededFlux = 7000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bismuth -NP",
                    NameToOrderByOverride = "NPIsotopes23",
                    DescriptionOverride = "Very slightly radioactive, contains bismuth-209 which can be irradiated into polonium-210.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/BiView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Bi.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 11f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 11f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.001f;
                        Instance.GetComponent<Fuel>().Criticality = 1000000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 1f;
                        Instance.GetComponent<Fuel>().FuelTime = 1f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0.00001f;
                        Instance.GetComponent<Radiation>().RadiationA = 0.00001f;
                        Instance.GetOrAddComponent<Irradiator>().Isotope = "Po-210 -NP";
                        Instance.GetComponent<Irradiator>().NeededFlux = 5500f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Graphite Moderator -NP",
                    NameToOrderByOverride = "NPModerator01",
                    DescriptionOverride = "Used in reactors to slow down neutrons",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/GraphiteModeratorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GraphiteModerator.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 7f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 7f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Heavy Water Moderator -NP",
                    NameToOrderByOverride = "NPModerator02",
                    DescriptionOverride = "Used in reactors to slow down neutrons even more. Decreases fuel lifetime by 5% down to 25%",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HeavyWaterModeratorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HeavyWaterModerator.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Boron Control Rod -NP",
                    NameToOrderByOverride = "NPControlRod01",
                    DescriptionOverride = "Used in reactors to decrease power",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/BoronControlRodView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BoronControlRod.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Lead Plating -NP",
                    NameToOrderByOverride = "NPPlating01",
                    DescriptionOverride = "Decreases radiation from fuel cells by 10% up to 95%",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/LeadPlatingView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/LeadPlating.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 13f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 13f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Depleted Uranium Plating -NP",
                    NameToOrderByOverride = "NPPlating01",
                    DescriptionOverride = "Decreases radiation from fuel cells by 10% up to 99.5% (Only use when you have 10 probably, might make lead plating worse because of way the code works)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/DUPlatingView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/DUPlating.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 29f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 29f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Heat Valve -NP",
                    NameToOrderByOverride = "NPValve",
                    DescriptionOverride = "Used to control flow of the heat",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HeatValveView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HeatValve.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        Instance.GetOrAddComponent<HeatValve>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Heat Sensor -NP",
                    NameToOrderByOverride = "NPSensor",
                    DescriptionOverride = "Used to detect temperature. Use blue activation to reverse it. (Uses code from Parts & contraptions mod by jimmyl to make setting heat possible which can be downloaded to convert constant activation into pulses)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/HeatSensorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HeatSensor.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 5f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 5f;
                        Instance.GetOrAddComponent<HeatSensor>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Geiger Counter -NP",
                    NameToOrderByOverride = "NPGeiger01",
                    DescriptionOverride = "Used to check current radiation levels",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/GeigerCounterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/GeigerCounter.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<GeigerCounter>();
                        Instance.GetComponent<GeigerCounter>().geigerclip = new AudioClip[] { ModAPI.LoadSound("geiger.wav") };
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Dosimeter -NP",
                    NameToOrderByOverride = "NPGeiger02",
                    DescriptionOverride = "Used to check current radiation levels",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/DosimeterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Dosimeter.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<Dosimeter>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Thermometer -NP",
                    NameToOrderByOverride = "NPGeiger03",
                    DescriptionOverride = "Used to check temperature over 9999C",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/ThermometerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Thermometer.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<Thermometer>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Decay meter -NP",
                    NameToOrderByOverride = "NPGeiger04",
                    DescriptionOverride = "Used to check how much fuel cell has decayed (you need 30% or less to reprocess it)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/DecayMeterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/DecayMeter.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<DecayMeter>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Isotope tester -NP",
                    NameToOrderByOverride = "NPGeiger05",
                    DescriptionOverride = "Used to check isotope name",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/IsotopeTesterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/IsotopeTester.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<IsotopeTester>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Power Meter -NP",
                    NameToOrderByOverride = "NPGeiger04",
                    DescriptionOverride = "Used to check higher charge than power gauge can",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/PowerMeterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PowerMeter.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<PowerMeter>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Super Heavy Isotope Container -NP",
                    NameToOrderByOverride = "NPGeiger05",
                    DescriptionOverride = "Used to safely transport super heavy isotopes",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/SHContainerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SHContainer.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 3f;
                        Instance.GetOrAddComponent<SHContainer>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fuel Reprocessor -NP",
                    NameToOrderByOverride = "NPReprocessor01",
                    DescriptionOverride = "Used to reprocess used fuel into useful isotopes",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/FuelReprocessorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FuelReprocessor.png", 0.7f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 30f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 30f;
                        Instance.GetOrAddComponent<FuelReprocessor>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fuel Maker -NP",
                    NameToOrderByOverride = "NPReprocessor02",
                    DescriptionOverride = "Used to make new fuel cells from fertile and fissile isotopes. Place 3 in (fertile/fertile/fissile) configuration to get LE fuels and in (Fertile/fissile/fissile) to get HE fuels. Activate again if it spewed out isotopes (which means that they weren't correct fuel combination)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/FuelMakerView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FuelMaker.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 30f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 30f;
                        Instance.GetOrAddComponent<FuelMaker>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Particle source -NP",
                    NameToOrderByOverride = "NPReprocessor03",
                    DescriptionOverride = "Used to shoot highly energetic particles at targets (isotopes or humans or anything you want) use red activation to check power level (Requires atleast 100KeV to fire) Default particle is Ca-48. Spawn only using E key cause there is bug with spawning it using Q.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/ParticleSourceView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ParticleSource.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 15f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 15f;
                        Instance.GetOrAddComponent<ParticleSource>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Particle -NP",
                    NameToOrderByOverride = "NPReprocessor031",
                    DescriptionOverride = "Particle from particle source. Do not spawn.",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/ParticleView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Particle.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                    NameOverride = "Iodine syringe -NP",
                    NameToOrderByOverride = "NPSyringe01",
                    DescriptionOverride = "Gives temporary radiation immunity (yes i know its not that realistic but people wanted something like this)",
                    CategoryOverride = ModAPI.FindCategory("Biohazard"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/IodineSyringeView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/IodineSyringe.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 3f;
                        Instance.GetOrAddComponent<IodineSyringe>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "U-238 Target -NP",
                    NameToOrderByOverride = "NPTarget01",
                    DescriptionOverride = "Used with particle source to create Copernicium-286 (10+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/U-238 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/U-238 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 10000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 3f;
                        Instance.GetComponent<Target>().Isotope = "Cn-286 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Pu-242 Target -NP",
                    NameToOrderByOverride = "NPTarget02",
                    DescriptionOverride = "Used with particle source to create Flevorium-290 (15+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Pu-242 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Pu-242 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 15000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 5f;
                        Instance.GetComponent<Target>().Isotope = "Fl-290 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Am-243 Target -NP",
                    NameToOrderByOverride = "NPTarget03",
                    DescriptionOverride = "Used with particle source to create Moscovium-291 (20+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Am-243 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Am-243 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 20000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 4f;
                        Instance.GetComponent<Target>().Isotope = "Mc-291 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cm-246 Target -NP",
                    NameToOrderByOverride = "NPTarget04",
                    DescriptionOverride = "Used with particle source to create Livermorium-294 (10+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cm-246 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cm-246 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 20000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 10f;
                        Instance.GetComponent<Target>().Isotope = "Lv-294 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Bk-248 Target -NP",
                    NameToOrderByOverride = "NPTarget04",
                    DescriptionOverride = "Used with particle source to create Tennessine-296 (40+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Bk-248 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Bk-248 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 40000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 3f;
                        Instance.GetComponent<Target>().Isotope = "Ts-296 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cf-252 Target -NP",
                    NameToOrderByOverride = "NPTarget04",
                    DescriptionOverride = "Used with particle source to create Oganesson-300 (150+ MeV particles are required) Might require multiple particle hits.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cf-252 TargetView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        foreach (UnityEngine.Object component in Instance.GetComponents<SyringeBehaviour>())
                            UnityEngine.Object.Destroy(component);
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cf-252 Target.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 6f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 6f;
                        Instance.GetOrAddComponent<Target>().EnergyNeeded = 150000f;
                        Instance.GetComponent<Target>().ParticlesNeeded = 1f;
                        Instance.GetComponent<Target>().Isotope = "Og-300 -NP";
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Cn-286 -NP",
                    NameToOrderByOverride = "NPIsotopesSH01",
                    DescriptionOverride = "Made from colliding Ca-48 with U-238, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Cn-286View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Cn-286.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 2000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1000f;
                        Instance.GetComponent<Radiation>().RadiationA = 1000f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 400f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Fl-290 -NP",
                    NameToOrderByOverride = "NPIsotopesSH02",
                    DescriptionOverride = "Made from colliding Ca-48 with Pu-242, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Fl-290View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Fl-290.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 1500f;
                        Instance.GetComponent<Radiation>().RadiationA = 1200f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 300f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Mc-291 -NP",
                    NameToOrderByOverride = "NPIsotopesSH03",
                    DescriptionOverride = "Made from colliding Ca-48 with Am-243, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Mc-291View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Mc-291.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 3000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 4f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3000f;
                        Instance.GetComponent<Radiation>().RadiationA = 1200f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 160f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Lv-294 -NP",
                    NameToOrderByOverride = "NPIsotopesSH04",
                    DescriptionOverride = "Made from colliding Ca-48 with Cm-246, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Lv-294View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Lv-294.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 4000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 5f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 4000f;
                        Instance.GetComponent<Radiation>().RadiationA = 1500f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 120f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Ts-296 -NP",
                    NameToOrderByOverride = "NPIsotopesSH05",
                    DescriptionOverride = "Made from colliding Ca-48 with Bk-248, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Ts-296View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Ts-296.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 6000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 3f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 3500f;
                        Instance.GetComponent<Radiation>().RadiationA = 3000f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 80f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Og-300 -NP",
                    NameToOrderByOverride = "NPIsotopesSH06",
                    DescriptionOverride = "Made from colliding Ca-48 with Cf-252, decays extrememly quickly and needs to be stored in special container.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Og-300View.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Og-300.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 10000f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 6f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 10000f;
                        Instance.GetComponent<Radiation>().RadiationA = 6000f;
                        Instance.GetOrAddComponent<Decay>().Lifetime = 60f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Antimatter -NP",
                    NameToOrderByOverride = "NPZAntimatter",
                    DescriptionOverride = "Made from colliding Antiproton with Positron (at 10 MeV each), disintegrates itself and object it comes contact with creating big explosion.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/AntimatterView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/Antimatter.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 1f;
                        Instance.GetComponent<Fuel>().Criticality = 10000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 0.01f;
                        Instance.GetComponent<Fuel>().FuelTime = 100000000f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 20000000f;
                        Instance.GetComponent<Radiation>().RadiationA = 6000000f;
                        Instance.GetOrAddComponent<Antimatter>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Rod"),
                    NameOverride = "Antimatter Wall -NP",
                    NameToOrderByOverride = "NPZAntimatterWall",
                    DescriptionOverride = "Only way to keep antimatter without it exploding. (This is the only item that antimatter won't explode on)",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/AntimatterWallView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/AntimatterWall.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Warp Bomb -NP",
                    NameToOrderByOverride = "NPZZFusion",
                    DescriptionOverride = "Basically a repurposed alcubierre drive, uses exotic matter to release energy comparable to a supernova, destroying star system its in and killing most life forms in 50 light year radius. Even though its made out of heavy casing the bomb itself is relatively light because of compressed exotic matter. The bomb will use exotic matter for 5 seconds to power up the drive releasing extreme amounts of electric energy, the bomb at this point can only be stopped by quickly annihilating the entire assembly.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/WarpBombView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/WarpBomb.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 2f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 2f;
                        Instance.GetOrAddComponent<WarpBomb>();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fusion Reactor -NP",
                    NameToOrderByOverride = "NPZZFusion",
                    DescriptionOverride = "Large machine in a shape of torus capable of sustaining nuclear fusion, must be powered with at least 250000 electrical energy after which it will start heating up if it has fuel inside of 2 ports on the sides. Put lighter of isotopes into left port and heavier one into right to fuse them together generating heat and fused element in the top port. The reactor also need at least 50 electric charge to keep running when ignited.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/FusionReactorView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FusionReactor.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 20f;
                        Instance.GetOrAddComponent<Fusion>();
                        Instance.GetOrAddComponent<CreateChild>().size = 3;
                        Instance.GetOrAddComponent<CreateChild>().offset[0] = new Vector3(-48.5f * ModAPI.PixelSize, 0f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[0] = ModAPI.FindSpawnable("Fusion Input 1 S -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[1] = new Vector3(48.5f * ModAPI.PixelSize, 0f);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[1] = ModAPI.FindSpawnable("Fusion Input 2 S -NP");
                        Instance.GetOrAddComponent<CreateChild>().offset[2] = new Vector3(0f, 48.5f * ModAPI.PixelSize);
                        Instance.GetOrAddComponent<CreateChild>().spawnable[2] = ModAPI.FindSpawnable("Fusion Output S -NP");
                        Instance.GetOrAddComponent<Fuel>().BaseRadiation = 0.01f;
                        Instance.GetComponent<Fuel>().Criticality = 10000000000f;
                        Instance.GetComponent<Fuel>().NeutronRadius = 0.01f;
                        Instance.GetComponent<Fuel>().FuelTime = 0.1f;
                        Instance.GetOrAddComponent<Radiation>().RadiationN = 0f;
                        Instance.GetComponent<Radiation>().RadiationA = 0f;
                    }
                }
            );
            /*ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "DT fusion pellet -NP",
                    NameToOrderByOverride = "NPZZFusion",
                    DescriptionOverride = "Highly pressurised pellet of Deuterium-Tritium Fuel. Heats up to 100M C and lasts for average amount of time.",
                    CategoryOverride = ModAPI.FindCategory("NuclearPlayground"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/DTFusionPelletView.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/DTFusionPellet.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.3f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.3f;
                    }
                }
            );*/

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Input S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ11",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineInputS.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Pull;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 1000 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 1000 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Input M -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ12",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineInputM.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Pull;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 2500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 2500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Input L -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ13",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineInputL.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Pull;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 5000 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 5000 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Boiler Input S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ14",
                    DescriptionOverride = "Boiler port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineOutputS.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Pull;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 2500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 2500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Output S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ21",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineOutputS.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 1000 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 1000 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Output M -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ22",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineOutputM.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 2500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 2500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Turbine Output L -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ23",
                    DescriptionOverride = "Turbine port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineOutputL.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 5000 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 5000 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Boiler Output S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ24",
                    DescriptionOverride = "Boiler port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineInputS.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 2500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 2500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Cooling Tower Coolant L -NP", 
                    NameToOrderByOverride = "ZZZZZZZZZ31",
                    DescriptionOverride = "Cooling tower port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CoolingTowerCoolantL.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 5000 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 5000 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fusion Input 1 S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ41",
                    DescriptionOverride = "Fusion Reactor port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FusionInputS1.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fusion Input 2 S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ41",
                    DescriptionOverride = "Fusion Reactor port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FusionInputS2.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 500 * 2.8f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Fusion Output S -NP",
                    NameToOrderByOverride = "ZZZZZZZZZ41",
                    DescriptionOverride = "Fusion Reactor port (do not spawn in by itself)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FusionOutputS.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 0.1f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<WaterTank>().PressureMode = BloodContainer.PressureDirection.Push;
                        Instance.GetOrAddComponent<WaterTank>().UpperLimit = 500 * 2.8f;
                        Instance.GetOrAddComponent<WaterTank>().LowerLimit = 500 * 2.8f;
                    }
                }
            );

            //Obsolete systems used for compatibility

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Small Turbine -NP",
                    NameToOrderByOverride = "NPTurbineZZZ0",
                    DescriptionOverride = "[OBSOLETE] Used to turn small amount of heat to electricity. (Works up to 3k C.)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineSmall.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 20f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<Turbine>().MultiplierTurbine = 1f;
                        Instance.GetOrAddComponent<Turbine>().MaxTemperature = 2500f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Medium Turbine -NP",
                    NameToOrderByOverride = "NPZZZTurbine1",
                    DescriptionOverride = "[OBSOLETE] Used to turn average amount of heat to electricity. (Works up to 10k C.)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineMedium.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 50f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<Turbine>().MultiplierTurbine = 1f;
                        Instance.GetOrAddComponent<Turbine>().MaxTemperature = 25000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Brick"),
                    NameOverride = "Large Turbine -NP",
                    NameToOrderByOverride = "NPZZZTurbine2",
                    DescriptionOverride = "[OBSOLETE] Used to turn large amounts of heat to electricity. (Works up to 100k C.) (can also be used in fusion reactor at greately reduced efficency, only real way to make power using fusion reactor)",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TurbineLarge.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 100f;
                        Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 100f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                        Instance.GetOrAddComponent<Turbine>().MultiplierTurbine = 1f;
                        Instance.GetOrAddComponent<Turbine>().MaxTemperature = 250000f;
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Metal Cube"),
                    NameOverride = "Cooling Tower -NP",
                    NameToOrderByOverride = "NPZZZTurbine3",
                    DescriptionOverride = "[OBSOLETE] Used to remove heat from reactor. Can be set to cool different amount of heat, might break with saving contraptions.",
                    CategoryOverride = ModAPI.FindCategory(null),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumbnails/Blank.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CoolingTower.png", 1f);
                        Instance.FixColliders();
                        Instance.GetComponent<PhysicalBehaviour>().InitialMass = 500f;
                        Instance.GetOrAddComponent<CoolingTower>();
                    }
                }
            );
        }
    }
}