using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class Particle : MonoBehaviour
    {
        public SpawnableAsset spawnable;
        public float Energy;
        public float ParticleType;
        private void FixedUpdate()
        {
            this.gameObject.GetComponent<Rigidbody2D>().velocity = transform.right * 50f;
        }
        private void OnCollisionEnter2D(Collision2D collider2D)
        {
            if (collider2D.gameObject.GetComponent<Target>() != null)
            {
                if (ParticleType == 0f)
                {
                    this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 0.001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0.1f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                }
                else
                {
                    this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 0.01f + Energy * 0.00001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = Energy * 0.0002f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = Energy * 0.001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = Energy * 0.0001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 1f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                }
            }
            else if (collider2D.gameObject.GetComponent<Particle>() != null)
            {
                if (collider2D.gameObject.GetComponent<Particle>().Energy > 10000f && collider2D.gameObject.GetComponent<Particle>().ParticleType == 1f && ParticleType == 2f && Energy > 10000f)
                {
                    this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 0.001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0.1f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                    Destroy(collider2D.gameObject);
                    GameObject instance;
                    spawnable = ModAPI.FindSpawnable("Antimatter -NP");
                    instance = UnityEngine.Object.Instantiate<GameObject>(spawnable.Prefab, this.transform.position, this.transform.rotation);
                    instance.transform.position += this.transform.up;
                    instance.AddComponent<DeregisterBehaviour>();
                    instance.AddComponent<TexturePackApplier>();
                    instance.AddComponent<AudioSourceTimeScaleBehaviour>();
                    instance.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = spawnable;
                    instance.name = spawnable.name;
                    CatalogBehaviour.PerformMod(spawnable, instance);
                }
                else
                {
                    this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 0.001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 0.1f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                }
            }
            else
            {
                if (ParticleType == 1f || ParticleType == 2f || ParticleType == 3f)
                {
                    this.gameObject.GetOrAddComponent<ExplosiveBehaviour>().Range = 0.01f + Energy * 0.00001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().Delay = 0f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveStrength = Energy * 0.0002f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().FragmentForce = Energy * 0.001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DestroyOnExplode = true;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().BurnPower = Energy * 0.0001f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().ShockwaveLiftForce = 1f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().DismemberChance = 0.01f;
                    this.gameObject.GetComponent<ExplosiveBehaviour>().TemperatureLimit = -1000f;
                }
                else if (ParticleType == 4f && collider2D.gameObject.GetComponent<Fusion>() != null)
                {
                    collider2D.gameObject.GetComponent<PhysicalBehaviour>().Temperature += 200f * Energy;
                    Destroy(this.gameObject);
                }
                else if (ParticleType == 0f)
                {
                    Destroy(this.gameObject);
                }
            }
        }
    }
}
