using UnityEngine;
using UnityEngine.Events;
using System;

namespace NP
{
    public class ParticleSource : MonoBehaviour
    {
        public SpawnableAsset spawnable;
        public float EnergyStored;
        public float Particle = 0f;
        private void FixedUpdate()
        {
            if (EnergyStored < 50000f)
            {
                EnergyStored += this.GetComponent<PhysicalBehaviour>().Charge * 0.005f;
            }
            else;
            {
                EnergyStored += this.GetComponent<PhysicalBehaviour>().Charge * 0.0025f;
            }
        }
        private void Use(ActivationPropagation activation)
        {
            if (activation.Channel == (ushort)0 && EnergyStored > 100f)
            {
                GameObject instance;
                spawnable = ModAPI.FindSpawnable("Particle -NP");
                instance = UnityEngine.Object.Instantiate<GameObject>(spawnable.Prefab, this.transform.position, this.transform.rotation);
                instance.transform.position += this.transform.right;
                instance.AddComponent<DeregisterBehaviour>();
                instance.AddComponent<TexturePackApplier>();
                instance.AddComponent<AudioSourceTimeScaleBehaviour>();
                instance.AddComponent<SerialiseInstructions>().OriginalSpawnableAsset = spawnable;
                instance.AddComponent<Particle>().Energy = EnergyStored;
                instance.GetComponent<Particle>().ParticleType = Particle;
                instance.name = spawnable.name;
                CatalogBehaviour.PerformMod(spawnable, instance);
                EnergyStored = EnergyStored * 0.3f;
            }
            else if (activation.Channel == (ushort)1)
            {
                ModAPI.Notify("Energy: " + EnergyStored + " KeV");
            }
            else if (activation.Channel == (ushort)2)
            {
                if (Particle == 0f)
                {
                    Particle = 1f;
                    ModAPI.Notify("Current Particle type: Positron (electron with positve charge)");
                }
                else if (Particle == 1f)
                {
                    Particle = 2f;
                    ModAPI.Notify("Current Particle type: antiproton (proton with negative charge)");
                }
                else if (Particle == 2f)
                {
                    Particle = 3f;
                    ModAPI.Notify("Current Particle type: Proton");
                }
                else if (Particle == 3f)
                {
                    Particle = 4f;
                    ModAPI.Notify("Current Particle type: Neutron");
                }
                else if (Particle == 4f)
                {
                    Particle = 0f;
                    ModAPI.Notify("Current Particle type: Ca-48");
                }
            }
        }
    }
}
