using UnityEngine;
using System;

namespace NP
{
    public class TurbineNew : MonoBehaviour
    {
        public float MultiplierTurbine = 1;
        public float MaxThroughput = 100f;
        public float Throughput;
        public float Inertia;
        public float Drag = 0.001f;

        public Liquid exhaustSteam = Liquid.GetLiquid("NP_EXHAUSTSTEAM");
        public Liquid steam = Liquid.GetLiquid("NP_HPS");
        WaterTank child1;
        WaterTank child2;
        private int done = 5;
        private void FixedUpdate()
        {
            if (done < 1 && done > -1)
            {
                done = -100;
                child1 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[0].ToString()).GetComponent<WaterTank>();
                child2 = GameObject.Find(this.GetComponent<CreateChild>().UniqueID[1].ToString()).GetComponent<WaterTank>();
                //ModAPI.Notify("Test: " + child1.UpperLimit);
            }
            else if (done > 0)
            {
                done--;
            }
            //ModAPI.Notify("Test: " + child1.GetAmount(steam) + "/" + 2.8f * 1f * MultiplierTurbine * child1.ScaledLiquidAmount + " Total: " + child1.TotalLiquidAmount);
            //ModAPI.Notify("Test: " + child2.GetAmount(exhaustSteam) * child2.UpperLimit + " " + child1.ScaledLiquidAmount);
            //GetPercentageOf and GetAmount seem to be switched around.
            if (child1.GetPercentageOf(steam) * child1.UpperLimit > 2.8f * 1f * MultiplierTurbine * child1.ScaledLiquidAmount * 10f && !(child2.IsFull(0.95f)) && MaxThroughput > Throughput)
            {
                //ModAPI.Notify("Test: " + child1.ScaledLiquidAmount + " " + child2.ScaledLiquidAmount);
                Throughput += 2.8f * 1f * MultiplierTurbine * child1.ScaledLiquidAmount;
                Inertia += MultiplierTurbine * child1.ScaledLiquidAmount * 50f;
                //GetComponent<PhysicalBehaviour>().Charge += 5f * MultiplierTurbine * child1.ScaledLiquidAmount * 1000f;
                child2.AddLiquid(exhaustSteam, 2.8f * 1f * MultiplierTurbine * child1.ScaledLiquidAmount * 10);
                child1.RemoveLiquid(steam, 2.8f * 1f * MultiplierTurbine * child1.ScaledLiquidAmount * 10);
            }
            //ModAPI.Notify("Throughput: " + Throughput + "/" + MaxThroughput);
            Throughput -= MaxThroughput * Time.deltaTime;
            if (Throughput < 0f)
                Throughput = 0;
            GetComponent<PhysicalBehaviour>().Charge = Inertia * 10f;
            Inertia *= 1f - Drag;
            if (Inertia < 0.1f)
                Inertia = 0;
        }
    }
}
