using UnityEngine;
using System;

namespace NP
{
    public class Water : Liquid
    {
        public const string ID = "WATER";

        public override string GetDisplayName() => "Water";

        public Water() => this.Color = new Color(0.6f, 0.6f, 0.8f);

        public override void OnEnterContainer(BloodContainer container)
        {
        }

        public override void OnEnterLimb(LimbBehaviour limb)
        {
        }

        public override void OnUpdate(BloodContainer container)
        {
            if (!(container is CirculationBehaviour circulationBehaviour) || !(circulationBehaviour.Limb.SpeciesIdentity == "Android"))
                return;
            circulationBehaviour.Limb.PhysicalBehaviour.Charge += 5f;
        }

        public override void OnExitContainer(BloodContainer container)
        {
        }
    }
}
