using UnityEngine;
using System;

namespace NP
{
    public class WaterPump : BloodContainer
    {
        public float UpperLimit = 100f;
        public float LowerLimit = 0f;
        public float Amount = 1.0f;
        public override bool AllowsOverflow => false;
        public override BloodContainer.PressureDirection Pressure => BloodContainer.PressureDirection.Push;

        public string LiquidID;
        public Liquid liquid;
        private void Start()
        {
            //ModAPI.Notify("Test: " + Liquid.GetLiquid(LiquidID));
            liquid = Liquid.GetLiquid(LiquidID);
        }
        private void FixedUpdate()
        {
            if(WaterBehaviour.IsPointUnderWater(this.gameObject.transform.position))
                this.AddLiquid(liquid, Amount);
        }
    }
}
